<template>
  <div class="app-container">
    <el-row type="flex" justify="space-between" ref="listQueryContainer" class="query-container">
      <el-col>
        <el-form :inline="true" style="flex-wrap: wrap" :model="listQuery" ref="listQuery" @submit.native.prevent @keyup.enter.native="onSubmit">
          <el-form-item label="平台" prop="platform">
            <el-select v-model="listQuery.platform" placeholder="请选择" clearable @clear="listQuery.platform=undefined" @change="onFilterChange">
              <el-option v-for="item in platformList.filter(it=>it.id>0)" :key="item.id" :label="item.label" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="类型" prop="method">
            <el-select v-model="listQuery.method" placeholder="请选择" clearable @clear="listQuery.method=undefined" @change="onFilterChange">
              <el-option v-for="item in methodList" :key="item.id" :label="item.id" :value="item.id"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="状态" prop="success">
            <el-select v-model="listQuery.success" placeholder="请选择" clearable @clear="listQuery.success=undefined" @change="onFilterChange">
              <el-option key="成功" label="成功" value="true"></el-option>
              <el-option key="失败" label="失败" value="false"></el-option>
            </el-select>
          </el-form-item>
          <el-form-item label="接口名" prop="uri">
            <el-input v-model.trim="listQuery.uri" maxlength="16" placeholder="请输入接口名" clearable @clear="listQuery.uri=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="用户ID" prop="userId">
            <el-input oninput="value=value.replace(/[^\d]/g,'')" v-model.trim="listQuery.userId" maxlength="16" placeholder="请输入用户ID" clearable @clear="listQuery.userId=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="用户IP" prop="userIp">
            <el-input v-model.trim="listQuery.userIp" maxlength="16" placeholder="请输入用户IP" clearable @clear="listQuery.userIp=undefined" @keyup.enter.native="onFilterChange">
              <i slot="suffix" class="el-input__icon el-icon-search" @click="onFilterChange"></i>
            </el-input>
          </el-form-item>
          <el-form-item label="请求时间范围" prop="createTimeRange">
            <el-date-picker
                v-model="listQuery.createTimeRange"
                value-format="timestamp"
                type="daterange"
                range-separator="-"
                start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="['00:00:00', '23:59:59']"
                @change="onFilterChange">
            </el-date-picker>
          </el-form-item>

          <el-form-item label-width="0">
            <el-button @click="onFilterChange" type="primary">查询</el-button>
            <el-button @click="resetFields" plain type="primary">重置</el-button>
            <el-button @click="onExport" plain type="primary">导出</el-button>
          </el-form-item>
        </el-form>
      </el-col>
      <form-clear :shrinkable="shrinkable" @clear="resetFields" @change="onExpansion"/>
    </el-row>

    <el-row>
      <el-button v-if="!editing" @click="onBatchDelete" plain type="primary">批量删除</el-button>
      <el-button v-if="editing" @click="onDeleteSelect" type="danger" :disabled="!(selectIds&&selectIds.length)">删除</el-button>
      <el-button v-if="editing" @click="onCancel" plain>取消</el-button>
    </el-row>

    <el-table :data="list" border stripe highlight-current-row ref="table" class="mt10" @sort-change="onSortChange" @selection-change="onTableSelectionChange" @cell-click="onCellClicked" @row-click="onRowClick">
      <el-table-column v-if="editing" type="selection" width="55" fixed></el-table-column>
      <el-table-column type="index" :index="indexCompute" label="序号" align="center" fixed="left" width="60px"/>
      <el-table-column align="center" fixed="left" label="用户" prop="userId" sortable="custom" width="75px">
        <template v-slot="scope">
          {{ scope.row.userId || '*' }}
        </template>
      </el-table-column>
      <el-table-column prop="platform" label="平台" sortable="custom" align="center" width="80px">
        <template v-slot="scope">
          {{ platformList.find(item => item.id === scope.row.platform).label }}
        </template>
      </el-table-column>
      <el-table-column align="center" label="用户IP" prop="userIp" sortable="custom" width="130px"/>
      <el-table-column align="center" label="类型" prop="method" sortable="custom" width="80px"/>
      <el-table-column prop="uri" label="接口名" sortable="custom" align="center" show-overflow-tooltip min-width="120px"/>
      <el-table-column align="center" label="状态" prop="success" sortable="custom" width="76px">
        <template v-slot="scope">
          <text-label v-if="scope.row.success" type="success">成功</text-label>
          <text-label v-else-if="!scope.row.success" type="danger">失败</text-label>
        </template>
      </el-table-column>
      <el-table-column align="center" label="异常位置" prop="fileName" sortable="custom" show-overflow-tooltip min-width="120px">
        <template v-slot="scope">
          <div v-if="!scope.row.success">{{ scope.row.fileName + ":" + scope.row.lineNumber }}</div>
          <div v-else>/</div>
        </template>
      </el-table-column>
      <el-table-column align="center" label="耗时(ms)" prop="time" sortable="custom" v width="105px"/>
      <el-table-column prop="request" label="请求参数" sortable="custom" align="center" min-width="120px">
        <template v-slot="scope">
          <el-popover
              placement="left"
              width="600"
              title="请求参数"
              v-if="scope.row.request && scope.row.request!=='{}'"
              trigger="hover">
            <el-card shadow="always">
              <json-viewer style="max-height: 400px;overflow: auto" :value="JSON.parse(scope.row.request)" :expand-depth=4 :show-array-index="false"></json-viewer>
            </el-card>
            <div class="text-ellipsis text-left" slot="reference"> {{ scope.row.request }}</div>
          </el-popover>
          <div v-else class="text-ellipsis text-left" slot="reference"> {{ scope.row.request }}</div>
        </template>
      </el-table-column>

      <el-table-column prop="response" label="响应结果" sortable="custom" align="center" min-width="120px" @click.native.stop>
        <template v-slot="scope">
          <el-popover
              placement="left"
              width="600"
              title="响应结果"
              v-if="scope.row.response && scope.row.response!=='{}'"
              trigger="hover">
            <el-card shadow="always">
              <json-viewer style="max-height: 400px;overflow: auto" :value="JSON.parse(scope.row.response)" :expand-depth=4 :show-array-index="false"></json-viewer>
            </el-card>
            <div class="text-ellipsis text-left" slot="reference"> {{ scope.row.response }}</div>
          </el-popover>
          <div v-else class="text-ellipsis text-left" slot="reference"> {{ scope.row.response }}</div>
        </template>
      </el-table-column>

      <el-table-column prop="createTime" label="请求时间" sortable="custom" align="center" width="120px">
        <template v-slot="scope">
          {{ scope.row.createTime | dateFormat("MM-dd HH:mm:ss") }}
        </template>
      </el-table-column>
      <el-table-column label="操作" align="center" width="80px">
        <template v-slot="scope">
          <el-link type="danger" icon="el-icon-delete" @click="onDelete(scope.row)">删除</el-link>
        </template>
      </el-table-column>
    </el-table>
    <pagination :total="total" :page.sync="listQuery.page" :size.sync="listQuery.size" @change="onPageChange"/>

    <el-dialog title="导出" :visible.sync="exportVisible" :close-on-click-modal="false" :close-on-press-escape="false" width="600px">
      <el-progress :text-inside="true" :stroke-width="24" :percentage="exportProgress" status="success"></el-progress>
      <el-button slot="footer" @click="onCancelExport">取 消</el-button>
    </el-dialog>

  </div>
</template>

<script>
import JsonViewer from 'vue-json-viewer';
import {dateFormat} from "@/utils/dateUtil"

export default {
  name: "SystemLog",
  components: {JsonViewer},
  data() {
    return {
      shrinkable: false, // 查询条件是否可以展开
      listQuery: { // 查询对象
        userId: undefined, // 用户ID
        userIp: undefined, // 用户IP
        platform: undefined, // 平台
        method: undefined, // 请求类型
        uri: undefined, // 请求接口名
        success: undefined, // 是否请求成功
        request: undefined, // 请求参数
        response: undefined, // 响应结果
        createTimeRange: [], // 请求时间
        createTimeStart: undefined,
        createTimeEnd: undefined,
        order: undefined,
        page: 1,
        size: 10
      },

      list: [], // 结果列表
      total: 0, // 总结果数量

      exportVisible: false, // 是否显示导出对话框
      exportData: [], // 导出数据
      exportPagination: { // 导出分页
        page: 1,
        size: 500,
      },
      exportProgress: 0, // 导出进度
      exportCancel: false, // 是否取消导出

      editing: false, // 表格编辑中

      selectItem: undefined, // 选中的单条记录
      selectIds: undefined, // 选中多条记录的id

      platformList: [{id: 0, label: "未知"}, {id: 1, label: "管理端"}, {id: 2, label: "小程序端"}],
      methodList: [{id: "GET"}, {id: "POST"}, {id: "PUT"}, {id: "DELETE"}],
    }
  },

  watch: {
    'listQuery.createTimeRange'(value) {
      if (value) {
        this.listQuery.createTimeStart = value[0];
        this.listQuery.createTimeEnd = value[1];
      } else {
        this.listQuery.createTimeStart = undefined;
        this.listQuery.createTimeEnd = undefined;
      }
    },
  },

  // 页面创建
  created() {
    this.initData();
  },

  // 页面挂载
  mounted() {
    this.initQuery();
    this.getList();
    this.initView();
    this.onCancel();
  },

  // keep-alive 显示界面时调用
  activated() {
    this.$refs["table"].doLayout();
  },

  // keep-alive 页面隐藏
  deactivated() {
  },

  methods: {
    // 初始化数据
    initData() {
    },
    // 初始化查询条件
    initQuery() {
      if (this.$store.state.app.paramCache) {
        let query = this.$storage.getData(this.$options.name);
        if (Object.keys(query).length > 0) {
          this.listQuery = query;
          if (query.order) {
            this.$refs.table.sort(query.order.substring(1), query.order.substring(0, 1) === "+" ? "ascending" : "descending");
          } else {
            this.$refs.table.clearSort();
          }
        }
      }
    },

    // 初始化视图
    initView() {
      this.$nextTick(() => {
        this.shrinkable = this.$store.state.app.filterShrink && this.$refs['listQuery'].$el.offsetHeight > 51;
      })
    },

    // 展开/收起查询条件
    onExpansion(show) {
      this.$refs['listQueryContainer'].$el.style.height = show ? "auto" : "51px";
    },

    // 表格索引
    indexCompute(index) {
      return index + 1 + (this.listQuery.page - 1) * this.listQuery.size;
    },

    // 表单提交
    onSubmit() {
      this.onFilterChange();
    },

    // 表单清除
    resetFields() {
      this.$refs['listQuery'].resetFields();
      this.listQuery.order = undefined;
      this.$refs.table.clearSort();
      this.onFilterChange();
    },

    // 批量删除
    onBatchDelete() {
      this.editing = true;
    },

    // 删除选中
    onDeleteSelect() {
      this.$confirm('此操作将永久删除选中的记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete("/v1/system/log/delete", {params: {ids: this.selectIds}}).then((data) => {
          if (this.list.length <= this.selectIds.length && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          this.selectIds = undefined;
          if (data > 0) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 取消编辑
    onCancel() {
      this.$refs['table'].clearSelection();
      this.editing = false;
    },

    // 删除
    onDelete(item) {
      this.$confirm('此操作将永久删除该记录, 是否继续?', '提示', {
        confirmButtonText: '确认',
        cancelButtonText: '取消',
        type: 'warning'
      }).then(async () => {
        this.$axios.delete(`/v1/system/log/delete/${item.id}`).then((data) => {
          if (this.list.length === 1 && this.listQuery.page > 1) {
            this.listQuery.page -= 1;
          }
          if (data > 0) {
            this.$message.success("删除成功");
          } else {
            this.$message.warning("删除失败");
          }
          this.getList();
        });
      });
    },

    // 数据选择
    onTableSelectionChange(val) {
      this.selectIds = val.map(item => item.id);
    },

    // 排序改变
    onSortChange({prop, order}) {
      if (order === "ascending") {
        this.listQuery.order = "+" + prop;
      } else if (order === "descending") {
        this.listQuery.order = "-" + prop;
      } else {
        this.listQuery.order = undefined;
      }
      this.onFilterChange();
    },

    // 单元格单击
    onCellClicked(row, column) {
      if (!this.editing && column.label !== "操作") {
        navigator.clipboard.writeText(row[column.property]);
        this.$message.success("内容已复制");
      }
    },

    // 行点击
    onRowClick(row, column, event) {
      this.$refs["table"].setCurrentRow(row);
      if (this.editing) {
        this.$refs["table"].toggleRowSelection(row);
      }
    },

    // 条件改变
    onFilterChange() {
      this.listQuery.page = 1;
      this.$nextTick(this.getList);
    },

    // 页码改变
    onPageChange() {
      this.getList();
    },

    // 加载列表
    getList() {
      // 缓存参数
      if (this.$store.state.app.paramCache) {
        this.$storage.setData(this.$options.name, this.listQuery);
      }

      this.$axios.get("/v1/system/log/list", {params: this.listQuery}).then(data => {
        this.list = data.list;
        this.total = data.total;
        this.$refs["table"].doLayout();
      });
    },

    json(text) {
      return text.replaceAll(/\'\n/g, '');
    },

    // 导出数据
    onExport() {
      if (this.total > 0) {
        this.exportPagination.page = 1;
        this.exportData = [];
        this.exportVisible = true;
        this.getExportData();
      }
    },

    // 取消导出
    onCancelExport() {
      this.exportVisible = false;
      this.exportCancel = true;
    },

    // 获取数据并导出
    getExportData() {
      if (!this.exportCancel) {
        this.$axios.get("/v1/system/log/list", {params: {...this.listQuery, ...this.exportPagination}}).then(data => {
          this.exportPagination.page++;
          this.exportData = this.exportData.concat(data.list);
          this.exportProgress = Math.round(this.exportData.length * 100 / this.total);
          if (this.exportData.length < this.total && data.list.length > 0) {
            this.getExportData();
          } else {
            this.exportVisible = false;

            let tHeader = ["序号",
              "用户ID",
              "平台",
              "用户IP",
              "请求类型",
              "请求接口名",
              "是否请求成功",
              "异常文件",
              "异常行号",
              "请求耗时",
              "请求参数",
              "响应结果",
              "请求时间",
            ];
            let filterVal = ["index",
              "userId",
              "platform",
              "userIp",
              "method",
              "uri",
              "success",
              "fileName",
              "lineNumber",
              "time",
              "request",
              "response",
              "createTime",
            ];
            let data = this.exportData.map((value, index) => filterVal.map((key) => {
              if (key === "index") {
                return index + 1;
              } else if (key === "platform") {
                return this.platformList.find(item => item.id === value[key]).label;
              } else if (key === "createTime") {
                return dateFormat("yyyy-MM-dd HH:mm:ss", value[key]);
              } else {
                return value[key];
              }
            }));
            import('@/utils/Export2Excel').then(excel => {
              excel.export_json_to_excel({
                header: tHeader, // 表头 必填
                data, // 具体数据 必填
                filename: '系统设置-操作日志信息列表', // 非必填
                autoWidth: true, // 非必填
                bookType: 'xlsx' // 非必填
              })
            })
          }
        });
      }
    }
  }
}
</script>

<style scoped lang="scss">
.app-container {

}
</style>
